
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>交叉编译和交叉调试环境搭建及使用 / iVAN</title>

    <meta name="description" content="交叉编译和交叉调试环境搭建及使用 交叉编译和交叉调试环境搭建及使用 1. 交叉编译器 1.1 交叉编译器介绍 在一种计算机环境中运行的编译程序,能编译出在另外一种环境下运行的代码,我们就称这种编译器支持交叉编译.这个编译过程就叫交叉编译.简单地说,就是在一个平台上生成另一个平台上的可执行代码,而这种工具就是交叉编译器(cross compiler). 1.2 搭建交叉编译环境  1.2.1 实验环境 交叉编译工具:arm-linux- 4.2.2 编译平台:ubuntu10.10 开发板类型:UT-S3C6410 1.2.2 搭">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">交叉编译和交叉调试环境搭建及使用</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>交叉编译和交叉调试环境搭建及使用</p>
<p><strong>1. 交叉编译器</strong></p>
<p>1.1 交叉编译器介绍</p>
<p>在一种计算机环境中运行的编译程序，能编译出在另外一种环境下运行的代码，我们就称这种编译器支持交叉编译。这个编译过程就叫交叉编译。简单地说，就是在一个平台上生成另一个平台上的可执行代码，而这种工具就是交叉编译器(cross compiler)。</p>
<p>1.2 搭建交叉编译环境 </p>
<p>1.2.1 实验环境<br />
<br />交叉编译工具：arm-linux- 4.2.2</p>
<p>编译平台：ubuntu10.10</p>
<p>开发板类型：UT-S3C6410</p>
<p>1.2.2 搭建步骤<br />
<br />1) 在/usr/local/下建立交叉编译器的安装目录arm：</p>
<p>sudo  mkdir /usr/local/arm</p>
<p> </p>
<p>2)将下载的交叉编译器包解压到/usr/local/arm目录下：</p>
<p>sudo tar jxvf cross-4.2.2-eabi.tar.bz2 -C /usr/local/arm/ </p>
<p> </p>
<p>3)解压成功后，修改PATH环境变量：</p>
<p>sudo vim  /etc/profile</p>
<p>在文件为加入交叉编译器arm-linux-所在的路径：</p>
<p>export PATH=$PATH:/usr/local/arm/4.2.2-eabi/usr/bin</p>
<p>然后退出vim。</p>
<p> </p>
<p>4) 更新一下配置文件/etc/profile：</p>
<p>source /etc/profile</p>
<p> </p>
<p> </p>
<p>5)检测是否安装成功：</p>
<p>现在就可以使用交叉编译器了，写一个测试程序helloworld，交叉编译下，看是否能在开发板上运行。</p>
<p> </p>
<p>         i. 交叉编译测试程序</p>
<p>arm-linux-gcc helloworld.c -o helloworld</p>
<p> </p>
<p>         ii.把生成的可执行文件helloworld复制到NFS的挂载目录下：</p>
<p>sudo  cp ./helloworld   /nfsboot</p>
<p>注意：本实验中开发板使用NFS挂载rootfs，nfsboot是NFS的挂载目录。</p>
<p> </p>
<p>        iii.在超级终端上运行：</p>
<p>./helloworld</p>
<p> </p>
<p>执行结果：</p>
<p> </p>
<p> </p>
<p><strong>2. 交叉调试GDB的介绍和使用</strong></p>
<p>2.1 GDB是什么？<br />
<br />GDB(GNU symbolic debugger) 简单的说是UNIX和LINUX下的一个调试工具。</p>
<p>2.2 GDB的主要特性<br />
<br />像所有的调试器一样，GDB可以让你调试一个程序，包括让程序在你希望的地方停下，此时你可以查看变量，寄存器，内存及堆栈。更进一步你可以修改变量及内存值。GDB是一个功能很强大的调试器，它可以调试多种语言。在此我们仅涉及C和C++的调试，而不包括其它语言。还有一点要说明的是，GDB是一个调试器，而不像VC一样是一集成环境。你可以使用一些前端工具如XXGDB，DDD等。他们都有图形化界面，因此用更方便，但它们仅是GDB的一层外壳。因此，你仍应熟悉GDB命令。事实上，当你使用这些图形化界面时间较长时，你才会发现熟悉GDB命令的重要性。</p>
<p> </p>
<p>2.3 GDB的安装<br />
<br />1)下载源码：</p>
<p>可以从<a href="http://www.gnu.org/software/gdb/download/" rel="external nofollow noreferrer">http://www.gnu.org/software/gdb/download/</a>获取到最新的GDB版本。</p>
<p>2)先做一些准备工作：</p>
<p>a)Sudo mkdir –p /usr/local/arm-gdb</p>
<p>b)Sudo chown –R cjok /usr/local/arm-gdb</p>
<p>c)cd Download</p>
<p>3)然后开始编译arm-linux-gdb</p>
<p>a)解压gdb包：</p>
<p>        tar zxvf gdb-7.2.tar.gz</p>
<p>b) 配置configure文件：</p>
<p>cd gdb-7.2/</p>
<p>./configure --target=arm-linux  --prefix=/usr/local/arm-gdb</p>
<p>c)编译和安装</p>
<p>make</p>
<p>sudo make install</p>
<p>d)cd到/usr/local/arm-gdb/目录下会看到</p>
<p>cd  /usr/local/arm-gdb</p>
<p>ls</p>
<p> </p>
<p>e)然后把arm-linux-gdb所在的路径添加到PATH环境变量中：</p>
<p>sudo vim /etc/profile</p>
<p>在文件为加入export PATH=$PATH:/usr/local/arm-gdb/bin</p>
<p>source /etc/profile</p>
<p>查看一下：</p>
<p> </p>
<p>    </p>
<p>4)编译gdbserver</p>
<p>a)配置configure文件</p>
<p>cd  gdb-7.2/gdb/gdbserver/</p>
<p>./configure --target=arm-linux --host=arm-linux</p>
<p>b)编译</p>
<p>make CC=arm-linux-gcc</p>
<p>c)把刚刚生成的gdbserver拷贝到NFS共享目录下，因为gdbserver最终是在目标机上运行：</p>
<p>sudo cp gdbserver /nfsboot/</p>
<p>5) 测试gdbserver</p>
<p>a)编译一个简单的程序helloworld.c</p>
<p>arm-linux-gcc –g helloworld.c –o helloworld</p>
<p>cp helloworld /nfsboot</p>
<p>*记得编译时，加-g选项</p>
<p>b)库问题</p>
<p>需要注意的是运行gdbserver还需要libthread_db库，如果你做的文件系统里没有相应的库，需要从交叉编译器内拷贝一个过去。</p>
<p>cp –avf /usr/local/arm/4.2.2-eabi/lib/libthread_db*   /nfsboot/lib</p>
<p> </p>
<p>注意：若不知道少了什么库，可以根据运行时错误提示拷贝。</p>
<p>c)到超级终端上启动gdbserver</p>
<p>./gdbserver 192.168.1.10:2345 helloworld</p>
<p>注意：我用的HOST IP是192.168.1.10，2345是监听端口，可以随便设定</p>
<p>然后会出现：</p>
<p> </p>
<p>d)然后在主机上启动gdb：</p>
<p>cd /nfsboot   </p>
<p>arm-linux-gdb helloworld</p>
<p>会出现：</p>
<p> </p>
<p> </p>
<p>链接到开发板上：</p>
<p>target remote 192.168.1.128:2345</p>
<p>注意：192.168.1.128是开发板的IP，2345是监听端口，要与上面设置的相同</p>
<p> </p>
<p>这是超级终端会出现：</p>
<p> </p>
<p>e)设置一下gdb环境变量</p>
<p> show solib-absolute-prefix</p>
<p> set solib-absolute-prefix /usr/local/arm/4.2.2-eabi/lib/</p>
<p>usr/local/arm/4.2.2-eabi/lib/ 是交叉编译器的库路径</p>
<p> show solib-search-path</p>
<p> set solib-search-path /nfsboot/lib/</p>
<p>/nfsboot/lib是文件系统的库路径</p>
<p> </p>
<p>注：红色部分为执行的指令。</p>
<p>到此环境已经搭建好，现在可以像在Linux下用GDB调试程序了。</p>
<p> </p>
<p>2.4 GDB的使用<br />
<br />OK，现在就可以开始交叉调试了。</p>
<p> </p>
<p>a) 把之前的helloworld修改一下：</p>
<p> </p>
<ol>
<li>1 #include &lt;stdio.h&gt;</li>
<li>  2</li>
<li>  3 int main(void)</li>
<li>  4 {</li>
<li>  5 int a, b, i;</li>
<li>  6 a = 3;</li>
<li>  7 b = 4;</li>
<li>  8 i = a + b;</li>
<li>  9 printf("i = %d\n", i);</li>
<li> 10 return 0;</li>
<li> 11 }</li>
</ol>
<p> </p>
<p> </p>
<p>b)交叉编译生成可执行文件之后，放到NFS的挂载目录下</p>
<p>  </p>
<p>      i.在超级终端上执行：</p>
<p>./gdbserver 192.168.1.10:2345 helloworld      </p>
<p>        ii.在HOST上执行：</p>
<p>arm-linux-gdb helloworld</p>
<p>target remote 192.168.1.128:2345</p>
<p>开始对程序进行调试：</p>
<p> </p>
<p> </p>
<p> </p>
<p>2.5 GDB的常用指令<br />
<br /> </p>
<p>   load：装入一个程序；</p>
<p>   symbol-file：装入符号库文件，可以是用-g参数编译的可执行文件；</p>
<p>   f(ile)：指定一个可执行文件进行调试，gdb将读取些文件的调试讯息，如f a.exe；</p>
<p>   l(ist)：列程序出源文件；</p>
<p>   r(un) ：装载完要调试的可执行文件后，可以用run命令运行可执行文件；</p>
<p>   b(reak)：设置断点（break point），如b 25，则在源程序的第25行设置一个断点，当程序执行到第25行时，就会产生中断；也可以使用b funcname，funcname为函数的名称；</p>
<p> </p>
<p>当程序运行到断点停下来时：</p>
<p>   c(ontinue)：c命令可以另中断的程序继续执行，直到下一个中断点或程序结束；</p>
<p>   p(rint)：输入某个变量的值，如程序定义了一个int a的就是，p a就会输出aa的当前值；</p>
<p>   n(ext)：程序执行到断点时中断执行，可以用n指令进行单步执行；</p>
<p>   s(tep)：程序执行到断点时中断执行，可以用s指令进行单步执行进某一函数；</p>
<p>   q(uit)：退出GDB</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-22 07:28:30</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e9%85%8d%e7%bd%ae/" title="配置">配置</a>, <a href="https://www.iamivan.net/tag/path/" title="path">path</a>, <a href="https://www.iamivan.net/tag/arm/" title="ARM">ARM</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>交叉编译和交叉调试环境搭建及使用的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z40kPrz.html" rel="bookmark">深入理解Tomcat系列之二：源码调试环境搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 最近对Tomcat的源码比较感兴趣,于是折腾了一番.要调试源码首先需要搭建环境,由于参考了几篇帖子发现都不怎么靠谱,最后还是折腾出来了,然而却花了足足一天的时间去搭建这个环境.发现都不是帖子的问题,主要是自己在搭建过程中忽略了一些细节,最后构建工程的时候一直失败,我也是醉了.所以本着共享的原则,把一些关键的步骤以及一些需要注意的细节写在博客中以飨读者. 下载Tomcat7源码 下载源码有多种方式,可以通过SVN直接拷贝到本地,svn地址在这里 下载之后源码的目录是这样的: 注意:要把bui			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ22aYz.html" rel="bookmark">用Zend Studio&plus;PHPnow&plus;Zend Debugger搭建PHP服务器调试环境步骤&lowbar;php技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本人主要是做ASP.NET开发的,但有时候也会接触到PHP,而且我认为PHP有很多源码值得学习,我们不是学习PHP代码的写法,而是学习源码的实现思路,或者免强叫为算法. 作为一名非专业的PHP开发者,想要较方便地读懂并搞清楚一个PHP功能模块的运行细节,搭建一个PHP调试环境,然后单步调试程序,以掌握程序的整个运行过程显的尤为重要. 一. 准备安装文件 1.PHPnow-1.5.6.&quot;PHPnow 是 Win32 下绿色免费的 Apache + PHP + MySQL 环境套件包.简易安装.快速			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2PBAop.html" rel="bookmark">Eclipse &plus; CDT &plus; YAGARTO &plus; J-Link&comma;STM32开源开发环境搭建与调试</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Eclipse+CDT+YAGARTO+J-Li:开源开发环境搭建与调试:作者:Chongqing:邮箱:ycq.no1@163.com:文档版本:V1.0:发布日期:2014-08-04:前言:此文档本着开源精神,基于LGPL协议发布:因网上开源的单片机.微控制器开发平台信息很少,故:因用ARM公司的KeiluVision开发环境开:因Eclipse是一个       Eclipse + CDT + YAGARTO + J-Link,STM32 开源开发环境搭建与调试 作者 :Chongqin			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bamaVJb.html" rel="bookmark">win7 windbg搭建双机调试环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 win7 windbg搭建双机调试环境 使用串口,win7 32bit可以连接上接收调试信息,但x64不能接受到调试信息. 解决方案 会不会跟操作系统的版本有关系呢,我猜测 解决方案二: 是不是i串口不支持64bit 解决方案三: 找到原因了,因为ghost win7的关系,换个x64的win7就好了 解决方案四: 不要用封装的系统,容易因系统在精简时候造成环境部分功能的缺失,建议还是用原生旗舰版吧.			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pPBPwrb.html" rel="bookmark">android-Android开发问题，安卓环境搭建完成后，调试过程中eclipse报错的问题</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				问题描述 Android开发问题,安卓环境搭建完成后,调试过程中eclipse报错的问题 安卓环境搭建 eclipse报 The connection to adb is down and a severe error has occured.You must restart adb and Eclipse.Please ensure that adb is correctly located at 'D:shithashadt-bundle-windows-x86_64-20140321sdk			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mv7x6Np.html" rel="bookmark">PHP&colon;windows下使用zend studio及相关产品搭建php调试环境</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				php是我这个JavaScripter向后走的第一站.&quot;工欲善其事,必先利其器&quot;,照搬在js.java来的经验,手册.调试环境.成熟代码范例是学习一项新技术的3个首要条件.中文的帮助手册已经有了,成熟的代码示例很多,就差调试环境了. (转帖请注明出处:http://blog.111cn.net/lenel)手册中关于调试环境的介绍了了数字,网上搜了一下php调试也没有得到完整可操作的好文,只得到了zend系列产品可以单步.远程调试. 经过反复尝试,终于搞通了,估计很多phper都在美美			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b24O6Zp.html" rel="bookmark">TI Davinci DM6446开发攻略&mdash;&mdash;开发环境搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				TI DAVINCI DM6446的开发环境搭建不像三星S3C2410,S3C2440,ATMEL的AT91SAM9260之类的单核ARM那么简单,因为DM6446还有DSP端的开发环境,以及双核之间的通信和程序编译等问题,所以开发攻略第一步就是要搭好开发环境.其实TI的EVM(TI 的开发板)也提供相关的EVM start guide(sprue66f.pdf),适合参考.         DAVINCI开发环境搭建基本上可分以下几步:         1) 准备好各种相关的windows,l			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKQ10dp.html" rel="bookmark">eclipse &plus; cdt &plus; gdb 进行arm linux 交叉调试 &lpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://blog.chinaunix.net/space.php?uid=20671208&amp;do=blog&amp;id=1580649 eclipse + cdt + gdb 进行arm linux 交叉调试     如何使用eclipse进行嵌入式Linux的开发 习惯了在windows环境下开发的程序员在转到Linux平台时经常会抱怨没有一个好用的集成开发环境.和windows下常用的一些开发软件相比,Linux自带的一些开发环境使用起来要么界面和操作不够方便.友好,要么功能不全			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lpde4zj.html" rel="bookmark">第一章 andriod studio 安装与环境搭建</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文 http://blog.csdn.net/zhanghefu/article/details/9286123 第一章   andriod studio 安装与环境搭建   一.Android Studio简介 Android Studio是Google新发布的Android应用程序开发环境,Android Studio是基于IntelliJ IDEA开发而成的.在Android Studio开发环境中,Android开发者可以非常方便地调试Android应用程序,Android Studi			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMldNaM.html" rel="bookmark" class="title">标准建站来看：CSS元素的class与ID命名常用关键字</a>
					<div>
						css|标准|关键字 由于项目中编写文档结构.编写CSS的人员较多,并与程序员协同工作,就需要统一class与id的名称,前天花了一点时间,按照大多人的习惯,制定了下面的常用关键字: 容 器:cont ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLOXNZM.html" rel="bookmark" class="title">PowerShell批量Rename文件</a>
					<div>
						有一堆的文件,名字是这样的:[abcd]2008.01.01.测试.txt,打算将收尾去掉,改成这个样子:2008.01.01.txt.在linux下应该很简单,大不了写个脚本就搞定了,不过我想在wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bo6P6Xz.html" rel="bookmark" class="title">WPF Bug清单之&lpar;4&rpar;&mdash;&mdash;点击RadioButton的空白没有反应</a>
					<div>
						在WPF BUG清单之二,介绍过RadioButton在绑定上的一个Bug.现在再来介绍它的另一个造成RadioButton的点击事件处理不正确的BUG.现象是:点在RadioButton的范围内,可 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXB4W5b.html" rel="bookmark" class="title">查看Win8系统应用所占空间大小</a>
					<div>
						查看Win8应用所占空间大小 首先,手指从屏幕右侧向中间划动或者按&quot;Win+I&quot;快捷键打开Win8的超级按钮(Charm栏),点击&quot;更改电脑设置&quot;. 在&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNrRlb.html" rel="bookmark" class="title">光影魔术手如何抠图、换背景</a>
					<div>
						  现在我们用光影魔术手来制作抠图及添加背景图片.需要注意的是抠取出来的前景图片大小.方向一定要适合背景图片,图片本身前景和背景差异比较大.且边缘较清晰的图抠取出来也就容易很多. 制作前大家先准备好一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwlQPvb.html" rel="bookmark" class="title">PhotoShop绘制富士山下的可爱MM画面效果过程</a>
					<div>
						首先呢,这次教程依然很坑爹,就是过程而已,木办法,没写过什么教程,自己画的也不多,期间得到了el-zheng大大的帮助不甚感激,总之玩笑归玩笑,继续努力就对了. 现在进入了公司,每天正常上班下班,回想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3oN1Nb.html" rel="bookmark" class="title">Apache URL重定向避免网址结尾斜线问题</a>
					<div>
						  描述: 每个网主都曾受到结尾斜线问题的折磨,若在URL中没有结尾斜线,服务器就会认为URL无效并返回错误,因为服务器会根据/~quux/foo去寻找foo这个档案,而非显示这个目录.其实很多时候, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWXdwep.html" rel="bookmark" class="title">如何删除在Excel2007的数据列表重复记录</a>
					<div>
						  在Excel 2007中删除重复记录的功能被设置在&quot;数据&quot;选项卡中(与排序和筛选等功能在一起) 列表重复记录-excel2007删除重复项&quot;&gt; 要使用这个功能, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MywP8lz.html" rel="bookmark" class="title">网游加速小助手怎么用？</a>
					<div>
						  1.下载安装网游加速小助手后,点击&quot;红毛闪电侠&quot;启动QQ网游加速小助手 2.点击&quot;立即加速&quot;,一键加速,创新智能识别技术,无需选游戏和区服 3.启动游戏,提 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9EaAkM.html" rel="bookmark" class="title">trinea&period;cn性能优化</a>
					<div>
						1.测试工具 主要使用百度统计的网站速度检测工具和google的pagespeed,网站各地访问速度测试使用webkaka. 调优前,百度检测结果为: 可以看出网页所有内容加载需要20多秒!!_!!  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJkq5Jb.html" rel="bookmark" class="title">对Object类中方法的深入理解</a>
					<div>
						看一下API中关于Object的介绍: 类 Object 是类层次结构的根类.每个类都使用 Object 作为超类. 所有对象(包括数组)都实现这个类的方法. 那么Object中到底有哪些方法,各自有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PWx4p.html" rel="bookmark" class="title">请叫我雷锋！Axure 元件库-常用元素1056枚下载</a>
					<div>
						请叫我雷锋!Axure 元件库-常用元素1056枚下载 时间:2014-10-13 13:32 来源:人人都是产品经理 作者:鹏飞 一套 Axure 常用元件库 &quot; 元素库 - icons_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYj4gep.html" rel="bookmark" class="title">java多线程通信之共享数据</a>
					<div>
						(1)当访问共同的代码的时候:可以使用同一个Runnable对象,这个Runnable对象中有这个共享数据,比如卖票系统就可以这么做. public class MutiThreadShareData ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEK7Az.html" rel="bookmark" class="title">数据库查询-关于这个SSH小程序思路问题</a>
					<div>
						问题描述 关于这个SSH小程序思路问题 编写一个成绩管理系统. (1)用数据库建立两个表,分别存储成绩信息(学号,姓名,课程名,成绩)和用户登录信息:(数据库类型不限) (2)用户登录后可以录入.删除 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWlevp.html" rel="bookmark" class="title">多种tabs切换的应用</a>
					<div>
						tabsMode 主要总结两种tabs切换的实现方式:JavaScript / jQuery:并最后实现一个jQuery的组件化开发 总体设计 整个tab设计可设计为一个大盒子(div)里面嵌套着两个 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
									<a href="https://www.iamivan.net/a/bQrGN0M.html" class="thumbnail">
				<img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvcmVhZC5odG1sNS5xcS5jb20vaW1hZ2U/c3JjPWZvcnVtJmFtcDtxPTUmYW1wO3I9MCZhbXA7aW1nZmxhZz03JmFtcDtpbWFnZVVybD1odHRwOi8vbW1iaXoucXBpYy5jbi9tbWJpei93YzdZTlBtM1l4VXN1R3lBU2hVUnYyVm5CTUR2QkdFSlZ5UzJMN0hXTnhsbzZhOEtxZU8wcjBLWlVENnpIcXNKeXl6QzB0T1Q3WmRHcDFqMUNqQW5ldy8wP3d4X2ZtdD1qcGVn.jpg">
							</a>
							<div class="info"   >
					<a href="https://www.iamivan.net/a/bQrGN0M.html" rel="bookmark" class="title">入侵总统DNA，未来犯罪新手段</a>
					<div>
						据传,美国政府一方面正在秘密收集各国领导人的DNA,另一方面也在不遗余力保护巴拉克·奥巴马的DNA.一旦这些基因密码被破解,就可能泄露一些对当事人有害的信息.在不远的将来,它们还可能提供更多信息--以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boRQ0jz.html" rel="bookmark" class="title">SpringMVC 中HttpMessageConverter简介</a>
					<div>
						一.问题描述: 在SprinvMVC的Web程序中,我在页面发送Ajax 的POST请求,然后在服务器端利用@requestBody接收请求body中的参数,当时运行过程中,我想服务器发送Ajax请求 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN7rJ7p.html" rel="bookmark" class="title">数据-实现excel和word对应映射，及时更新</a>
					<div>
						问题描述 实现excel和word对应映射,及时更新 有个200页的word,用的数据都是一个excel文件里的数据(这个excel有70个sheet表) 实现更换另一个excel,这个word里的数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlKadab.html" rel="bookmark" class="title">下载盗号木马，盗取中毒电脑的隐私信息</a>
					<div>
						木马下载器播放广告弹窗远程下载大量病毒 据瑞星&quot;云安全&quot;系统统计,本周瑞星共截获了896,449个钓鱼网站,共有456万网民遭遇钓鱼网站攻击.瑞星安全专家提醒用户,在本周截获的病毒 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pkeoqdb.html" rel="bookmark" class="title">ccf-CCF上模板生成系统运行出错</a>
					<div>
						问题描述 CCF上模板生成系统运行出错 评测结果显示运行出错,自己实在看不出来了,望大神解惑... #include #include #include #include #include using ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPB7yqb.html" rel="bookmark" class="title">Ubuntu创始人：Ubuntu手机明年进入中国市场</a>
					<div>
						Ubuntu创始人:Ubuntu手机明年进入 中国市场 发表于2013-03-22 07:13| 次阅读| 来源CSDN| 0 条评论| 作者整理 Ubuntu操作系统开源移动操作系统智能手机iOSA ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MY5P16M.html" rel="bookmark" class="title">MySQL &CenterDot; 源码分析 &CenterDot; 内存分配机制</a>
					<div>
						前言 内存资源由操作系统管理,分配与回收操作可能会执行系统调用(以 malloc 算法为例,较大的内存空间分配接口是 mmap, 而较小的空间 free 之后并不归还给操作系统 ),频繁的系统调用必然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRLEkp.html" rel="bookmark" class="title">为什么dreamweaver绑定数据集后出问题&quest;</a>
					<div>
						问题描述 为什么dreamweaver绑定数据集后出问题? 解决方案 解决方案二:路径不对,文件名不对~asp默认的文件名是default.asp,一般设计网页的首页命名为index.html,活其他 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOJ0J8p.html" rel="bookmark" class="title">求GABOR滤波的matlab代码</a>
					<div>
						问题描述 求GABOR滤波的matlab代码 数字图像处理gabor滤波代码不知道,还有主成分分析代码,急需急需???..////////////// 解决方案 http://blog.csdn.ne ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB8PNM.html" rel="bookmark" class="title">J2ME中XML文件能否通过一个ID号直接解析出对应的其它项</a>
					<div>
						问题描述 如XML文件是样:&lt;?xmlversion=&quot;1.0&quot;encoding=&quot;utf-8&quot;?&gt;&lt;PACKAGE&gt;&lt;CURRE ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR58Op.html" rel="bookmark" class="title">浅谈地方类网站如何发展</a>
					<div>
						我的观点:在门户横行的时代,地方类对于我们站长来说或许是个更容易突围的薄弱地带,特别是目前网络还不是很发达的http://www.aliyun.com/zixun/aggregation/6249.h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baB30nM.html" rel="bookmark" class="title">英语四级考又现泄题门：开考5分钟网络现考题</a>
					<div>
						本报上海21日消息 今年英语四级考试再一次出现泄题事件.昨天上午,四级考试开始5分钟之后,一道作文题就已出现在一家四六级考试网站的讨论版上,而按照考试纪律,&quot;考生在考试全过程中,不得中途退场 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5RaRqz.html" rel="bookmark" class="title">迷宫之广度优先搜索</a>
					<div>
						jobdu 1456   题目1456:胜利大逃亡   题目描述: Ignatius被魔王抓走了,有一天魔王出差去了,这可是Ignatius逃亡的好机会.魔王住在一个城堡里,城堡是一个A*B*C的立方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPlPxZp.html" rel="bookmark" class="title">图解css3：核心技术与案例实战&period; 2&period;3　层次选择器</a>
					<div>
						2.3 层次选择器 层次选择器通过HTML的DOM元素间的层次关系获取元素,其主要的层次关系包括后代.父子.相邻兄弟和通用兄弟几种关系,通过其中某类关系可以方便快捷地选定需要的元素. 2.3.1 层次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ZR2Vb.html" rel="bookmark" class="title">Illustrator利用钢笔工具绘制闭合三角锥形教程</a>
					<div>
						给各位Illustrator软件的使用者们来详细的解析分享一下利用钢笔工具绘制闭合三角锥形的教程. 教程分享: Illustrator的作用就是创建路径.用户可以用它来绘制描述线条和图形的数学算法矢量 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
